////////////////////////////////////////////////////////////////////////////////
//
//	This is code for the Singapore Weather Gadget prototype
//
////////////////////////////////////////////////////////////////////////////////

var g_timerMilliSecs            = 5000;
var g_timer						= null;
var g_viewElements				= null;

var g_tickCounter				= 0;
var g_ticksPerUpdate			= 12;


var g_dataStale					= true;
var g_freshDataAvailable		= false;		
var g_refreshing				= false;		
var g_rawWeatherData			= "unavailable";

var g_currentLocalForcastIndex 	= 0;
var g_arrayWeatherData			= null;

var g_weatherSourceUrl			= "http://app.nea.gov.sg/cms/htdocs/mss3.asp";
var g_weatherImageUrl			= "http://www.nea.gov.sg/cms/mss/gif/longcast.gif";

var oMachine;
var oDial;

var col_EasternSg = new Array();
var col_WesternSg = new Array();
var col_NorthernSg = new Array();
var col_SouthernSg = new Array();
var col_CentralSg = new Array();

var g_zone;

////////////////////////////////////////////////////////////////////////////////
//
// GADGET Related
//
////////////////////////////////////////////////////////////////////////////////

System.Gadget.settingsUI    	= "settings.html";

// This method ties GUI objects in the host HTML document to this javascript logic
// In simpler terms, if you want to access objects in the Gadget HTML file to update
// its values, you need to make sure you 'hook up' those objects in this method
function viewElementsObject()
{
	this.weatherImage 		= document.getElementById("weatherImage");
	this.localForcastText 	= document.getElementById("localForcastText");
	this.footerText 		= document.getElementById("footerText");
	this.LocalForcast       = document.getElementById("LocalForcast");
	this.FooterNotes        = document.getElementById("FooterNotes");
}
////////////////////////////////////////////////////////////////////////////////////
function populateLocationArrays()
{
    col_WesternSg[0] = "BUKIT BATOK ";
    col_WesternSg[1] = "CLEMENTI ";
    col_WesternSg[2] = "HOLLAND VILLAGE ";
    col_WesternSg[3] = "JURONG INDUSTRIAL ESTATE ";
    col_WesternSg[4] = "JURONG EAST/WEST ";
    col_WesternSg[5] = "PANDAN ";
    col_WesternSg[6] = "QUEENSTOWN ";
    col_WesternSg[7] = "TUAS ";
    col_WesternSg[8] = "WEST COAST ";
    
    col_EasternSg[0] = "BEDOK ";
    col_EasternSg[1] = "CHANGI ";
    col_EasternSg[2] = "CHAI CHEE ";
    col_EasternSg[3] = "KALLANG ";
    col_EasternSg[4] = "MARINE PARADE ";
    col_EasternSg[5] = "PASIR RIS ";
    col_EasternSg[6] = "SIMEI ";
    col_EasternSg[7] = "TAMPINES ";
    
    col_NorthernSg[0]  = "BUKIT PANJANG ";
    col_NorthernSg[1]  = "CHOA CHU KANG ";
    col_NorthernSg[2]  = "HOUGANG ";
    col_NorthernSg[3]  = "KRANJI ";
    col_NorthernSg[4]  = "LIM CHU KANG ";
    col_NorthernSg[5]  = "PASIR PANJANG ";
    col_NorthernSg[6]  = "PUNGGOL ";
    col_NorthernSg[7]  = "PULAU TEKONG ";
    col_NorthernSg[8]  = "PULAU UBIN ";
    col_NorthernSg[9]  = "PULAU PAWAI ";
    col_NorthernSg[10] = "SELETAR ";
    col_NorthernSg[11] = "SERANGOON ";
    col_NorthernSg[12] = "SEMBAWANG ";
    col_NorthernSg[13] = "WOODLANDS ";
    col_NorthernSg[14] = "YISHUN ";
    
    col_SouthernSg[0] = "CITY ";
    col_SouthernSg[1] = "SENTOSA ";
    col_SouthernSg[2] = "SOUTHERN ISLAND ";
    
    col_CentralSg[0] = "ANG MO KIO ";
    col_CentralSg[1] = "BISHAN ";
    col_CentralSg[2] = "BUKIT TIMAH ";
    col_CentralSg[3] = "MACPHERSON ";
    col_CentralSg[4] = "MACRITCHIE RESERVOIR ";
    col_CentralSg[5] = "TOA PAYOH ";
    col_CentralSg[6] = "TELOK BLANGAH ";
    col_CentralSg[7] = "PEIRCE RESERVOIR ";
    col_CentralSg[8] = "UPPER BUKIT TIMAH ";
}
////////////////////////////////////////////////////////////////////////////////////
function UpdateZone()
{
    if(System.Gadget.Settings.read("zone") == "")
    {
        str_zone = "all";
    }
    else
    {
        str_zone = System.Gadget.Settings.read("zone");
    }
}
////////////////////////////////////////////////////////////////////////////////////
function DebugFunction()
{
    if(str_zone == "central")
    {
        for(i=0; i<9; i++)
        {
            prompt(col_CentralSg[i]);
            break;
        }
    }
    else if(str_zone == "northern")
    {
        for(i=0; i<15; i++)
        {
            prompt(col_NorthernSg[i]);
        }
    }
    else if(str_zone == "southern")
    {
        for(i=0; i<3; i++)
        {
            prompt(col_SouthernSg[i]);
        }
    }
    else if(str_zone == "eastern")
    {
        for(i=0; i<8; i++)
        {
            prompt(col_EasternSg[i]);
        }
    }
    else if(str_zone == "western")
    {
        for(i=0; i<9; i++)
        {
            prompt(col_WesternSg[i]);
        }
    }
    else
    {
    }
}
////////////////////////////////////////////////////////////////////////////////////
function loadUp()
{   
    //Set event for onUndock and onDock
    System.Gadget.onUndock = checkState;
    System.Gadget.onDock = checkState;
    
	//Hook up Gadget's HTML GUI objects to this javascript code
    g_viewElements = new viewElementsObject();

    populateLocationArrays();
    //
    //DebugFunction();
    //
	refreshWeatherData();
    startTimer();
    checkState();
}
////////////////////////////////////////////////////////////////////////////////////
function refreshWeatherData() //refreshWeatherData and associated methods
{
	req = false;

	req = new ActiveXObject("Microsoft.XMLHTTP");

	if(req) 
	{
		g_refreshing = true;
		
		// We are going to do an async pull of data
		// Telling the req object to call 'processReqChange' whenever
		// the state of the req object changes
		req.onreadystatechange = processReqChange;
		
		// Here we go...
		req.open("GET", g_weatherSourceUrl, true);
		req.send("");
	}
}
////////////////////////////////////////////////////////////////////////////////////
function processReqChange() 
{
    // only if req shows "loaded"
    if (req.readyState == 4) 
    {
        // only if "OK"
        if (req.status == 200) 
        {
        	g_dataStale				= false;
            g_freshDataAvailable 	= true;
            g_refreshing 			= false;
            g_rawWeatherData 		= req.responseText;
        } 
        else 
        {
        	g_dataStale				= true;
        	g_freshDataAvailable 	= false;
        	g_refreshing			= false;
        	g_rawWeatherData		= "unavailable";
        	
            alert("There was a problem retrieving the XML data:\n" +
                req.statusText);
        }
    }
}
////////////////////////////////////////////////////////////////////////////////////
function startTimer()
{
	g_timer = setInterval(tickTock, g_timerMilliSecs);
}
////////////////////////////////////////////////////////////////////////////////////
function tickTock()// This method is called everytime a 'tick' activity occurs
{	
	// 1. We update the tick counter... this is used to know when we
	//    need to reload weather data
	g_tickCounter++;

	// 2. We cycle the GUI's local forcast text to the next one we have
	//    in the forcast array
	cycleLocalForcastText();
	
	// 3. We check to see if the tickCounter has exceeded the threshold
	//    of the data becoming stale.  If it is, we flag the data as stale
	if (g_tickCounter > g_ticksPerUpdate)
	{
		g_dataStale = true;
		g_tickCounter = 0;
	}
	
	// 4. We check to see if the data is flagged as stale. If it is and we
	//    are not attempting to refresh the data, we kick off refresh data
	//    activity.
	if (g_dataStale && !g_refreshing)
	{
		refreshWeatherData();
	}
	
	// 5.  If there is fresh weather data Only process when fresh data available and 
	// we are not currently refreshing data
	if (g_freshDataAvailable && !g_refreshing)
	{
		var myregexp = /Arial">([\w,\s,/]*)</;
		
		var match = null;
		
		// Temp variable
		var count = 0;
		
		var resultArray = new Array();
				
		var moreToProcess 	= true;
		var city			= "";
		var weather			= "";
		
		while(moreToProcess)
		{
			// Look for city
			match = myregexp.exec(g_rawWeatherData);
			
			// Found city... lets look for current condition
			if (match != null && match.length > 1)
			{
				city = match[1];
				
				// Cut out what has been already evaluated for matching
				g_rawWeatherData = g_rawWeatherData.substring(myregexp.lastIndex + 1, g_rawWeatherData.length);
				
				// Look for current condition
				match = myregexp.exec(g_rawWeatherData);
				
				//Refresh Settings
				UpdateZone();
				
				// Found condition... lets add to the result array
				if (match != null && match.length > 1)
				{
				    weather = match[1];
					
					//>>>DONE
					if(str_zone == "central")
                    {
                        for(i=0; i<9; i++)
                        {   
                            if(city == col_CentralSg[i])
                            {
                                resultArray.push(city + " - " + weather);
                                break;
                            }
                        }
                    }
                    else if(str_zone == "northern")
                    {
                        for(i=0; i<15; i++)
                        {
                            if(city == col_NorthernSg[i])
                            {
                                resultArray.push(city + " - " + weather);
                                break;
                            }
                        }
                    }
                    else if(str_zone == "southern")
                    {
                        for(i=0; i<3; i++)
                        {
                            if(city == col_SouthernSg[i])
                            {
                                resultArray.push(city + " - " + weather);
                                break;
                            }
                        }
                    }
                    else if(str_zone == "eastern")
                    {
                        for(i=0; i<8; i++)
                        {
                            if(city == col_EasternSg[i])
                            {
                                resultArray.push(city + " - " + weather);
                                break;
                            }
                        }
                    }
                    else if(str_zone == "western")
                    {
                        for(i=0; i<9; i++)
                        {
                            if(city == col_WesternSg[i])
                            {
                                resultArray.push(city + " - " + weather);
                                break;
                            }
                        }
                    }
                    else
                    {
                        // Add the formatted result to the result array
					    resultArray.push(city + " - " + weather);
                    }
					
					
					// Cut out what has been already evaluated for matching
					g_rawWeatherData = g_rawWeatherData.substring(myregexp.lastIndex + 1, g_rawWeatherData.length);					
				}
				else
				{
					moreToProcess = false;
				}				
			}
			else
			{
				moreToProcess = false;
			}
		}
		g_arrayWeatherData = resultArray;
		
		g_freshDataAvailable = false;
		
		updateWeatherImage();
		updateLastUpdatedValue();
	}
}
////////////////////////////////////////////////////////////////////////////////////
function updateWeatherImage()
{
	g_viewElements.weatherImage.src = g_weatherImageUrl;
	
}
////////////////////////////////////////////////////////////////////////////////////
function cycleLocalForcastText()
{
	// The weather data is not empty
	if (g_arrayWeatherData != null)
	{
		// The index is not out of bounds
		if (g_currentLocalForcastIndex < g_arrayWeatherData.length)
		{
			g_viewElements.localForcastText.innerText = g_arrayWeatherData[g_currentLocalForcastIndex];
			g_currentLocalForcastIndex++;
		}
		// The index is out of bounds and there is data in the weather data array
		else if (g_arrayWeatherData.length > 0)
		{
			g_currentLocalForcastIndex = 0;
			
			g_viewElements.localForcastText.innerText = g_arrayWeatherData[g_currentLocalForcastIndex];
			g_currentLocalForcastIndex++;
		}
		// Whatever... set back to zippo
		else
		{
			g_currentLocalForcastIndex = 0;
		}
	}
	
}
////////////////////////////////////////////////////////////////////////////////////
function updateLastUpdatedValue()
{
	var currentTime = new Date();
	var theday   	= currentTime.getDay();
	var thedayword 	= "";
	var themonth 	= currentTime.getMonth()+1;
	var thetoday 	= currentTime.getDate();
	var thehour 	= currentTime.getHours();
	var themin		= currentTime.getMinutes();
	var thesec		= currentTime.getSeconds();
	
	switch (theday) 
	{
	   case 1:
	      thedayword = "Mon";
	      break;
	   case 2:
	      thedayword = "Tue";
	      break;
	   case 3:
	      thedayword = "Wed";
	      break;
	   case 4:
	      thedayword = "Thr";
	      break;
	   case 5:
	      thedayword = "Fri";
	      break;
	   case 6:
	      thedayword = "Sat";
	      break;
	   case 7:
	      thedayword = "Sun";
	      break;
	   default:
	      thedaywork = "Huh?";
	}
	
    g_viewElements.footerText.innerText = thedayword + " " + themonth + "/" + thetoday + " " + thehour + ":" + themin;
 
}
////////////////////////////////////////////////////////////////////////////////////
function dockedState()
{
    with(document.body.style)
            width=174,height=177;
    System.Gadget.background="url(bgsmall.png)";
                
    g_viewElements.weatherImage.style.width = "159px";
    g_viewElements.weatherImage.style.height = "99px";
                
    g_viewElements.LocalForcast.style.top = "137px";
    g_viewElements.LocalForcast.style.left = "10px";
    
    g_viewElements.FooterNotes.style.top = "157px";
    g_viewElements.FooterNotes.style.left = "10px";
}
//////////////////////////////////////////////////////////////////////
function undockedState()
{
    with(document.body.style)
        width=328,height=271;
        
    System.Gadget.background="url(bglarge.png)";
                
    g_viewElements.weatherImage.style.width = "316px";
    g_viewElements.weatherImage.style.height = "196px";
                
    g_viewElements.LocalForcast.style.top = "232px";
    g_viewElements.LocalForcast.style.left = "10px";
    
    g_viewElements.FooterNotes.style.top = "252px";
    g_viewElements.FooterNotes.style.left = "10px";
}
//////////////////////////////////////////////////////////////////////
function checkState()
{
    if(!System.Gadget.docked)
    {
        undockedState();
    }
    else if (System.Gadget.docked)
    {
        dockedState();
    }
}
//////////////////////////////////////////////////////////////////////